﻿Friend Class JSONObject

    Private ch As Char = ""
    Private at As Integer = 0
    Private ft As Boolean = True
    Private text As String
    Private internalObj As Object

    Private Sub white()
        While True
            If (ch <= " ") Then
                Me.next()
            ElseIf (ch = "/") Then
                Select Case Me.next()
                    Case "/"
                        While (ch <> "\n" And ch <> "\r")
                            Me.next()
                        End While
                    Case "*"
                        Me.next()
                        While True
                            If (ch <> "") Then
                                If (ch = "*") Then
                                    If (Me.next() = "/") Then
                                        Me.next()
                                        Exit While
                                    End If
                                Else
                                    Me.next()
                                End If
                            Else
                                Throw New Exception("Unterminated comment")
                            End If
                        End While

                    Case Else
                        Throw New Exception("Syntax error")
                End Select
            Else
                Exit While
            End If
        End While
    End Sub

    Private Function [next]() As Char
        If at < text.Length Then
            ch = text.ToCharArray.GetValue(at)
        Else
            ch = ""
        End If
        at += 1
        Return ch
    End Function

    Private Function str() As String
        Dim i As Integer
        Dim s As String = ""
        Dim t As String = ""
        Dim u As Integer

        Dim outer As Boolean = False

        If (ch = Chr(34)) Then
            While (Me.next() <> "")
                If (ch = Chr(34)) Then
                    Me.next()
                    Return s
                ElseIf (ch = "\") Then
                    Select Case (Me.next())
                        Case "b"
                            s += vbBack
                        Case "f"
                            s += vbFormFeed
                        Case "n"
                            s += vbNewLine
                        Case "r"
                            s += vbCr
                        Case "t"
                            s += vbTab
                        Case "u"
                            u = 0
                            For i = 0 To 3
                                t += Me.next()
                            Next
                            s += ChrW(System.Convert.ToUInt16(t, 16))
                        Case Else
                            s += ch
                    End Select
                Else
                    s += ch
                End If
            End While
        End If
        Throw New Exception("Bad string")
    End Function

    Private Function arr(Optional ByVal ClassType As Type = Nothing) As Array
        Dim a As New ArrayList
        Dim i As Integer

        If (ch = "[") Then
            Me.next()
            Me.white()
            If (ch = "]") Then
                Me.next()
                If ClassType Is Nothing Then
                    Return a.ToArray(GetType(String))
                Else
                    Return a.ToArray(ClassType)
                End If
            End If
            While True
                If ClassType Is Nothing Then
                    a.Add(Me.value())
                Else
                    a.Add(Me.value(ClassType))
                End If

                Me.white()
                If (ch = "]") Then
                    Me.next()
                    If ClassType Is Nothing Then
                        Return a.ToArray(GetType(String))
                    Else
                        Return a.ToArray(ClassType)
                    End If
                ElseIf (ch <> ",") Then
                    Exit While
                End If
                Me.next()
                Me.white()
                i = i + 1
            End While
        End If
        Throw New Exception("Bad array")
    End Function

    Private Function obj(ByRef theObj As Object) As Object
        Dim k As String '????

        If (ch = "{") Then
            Me.next()
            Me.white()
            If (ch = "}") Then
                Me.next()
                Return theObj
            End If
            While True
                k = Me.str()
                Me.white()
                If (ch <> ":") Then
                    Exit While
                End If
                Me.next()

                Try
                    '****** SETTO LA PROPRIETA'
                    Dim pi As System.Reflection.PropertyInfo = theObj.GetType().GetProperty(k)
                    If pi Is Nothing Then Return False
                    ' convert the value to the expected type
                    ' attempt the assignment
                    If pi.CanWrite Then
                        pi.SetValue(theObj, Convert.ChangeType(Me.value(pi.PropertyType), pi.PropertyType), Nothing)
                    Else
                        Me.value()
                    End If

                Catch ex As Exception
                    Me.value()
                End Try

                Me.white()
                If (ch = "}") Then
                    Me.next()
                    Return theObj
                ElseIf (ch <> ",") Then
                    Exit While
                End If
                Me.next()
                Me.white()
            End While
        End If
        Throw New Exception("Bad object")
    End Function

    Private Function num() As Double
        Dim n As String = ""
        Dim v As Double

        If ch = "-"c Then
            n = "-"c
            Me.next()
        End If
        Do While ch >= "0"c AndAlso ch <= "9"c
            n += ch
            Me.next()
        Loop
        If ch = "."c Then
            n &= "."c
            Me.next()
            Do While ch >= "0"c AndAlso ch <= "9"c
                n += ch
                Me.next()
            Loop
        End If
        If ch = "e"c OrElse ch = "E"c Then
            n += ch
            Me.next()
            If ch = "-"c OrElse ch = "+"c Then
                n += ch
                Me.next()
            End If
            Do While ch >= "0"c AndAlso ch <= "9"c
                n += ch
                Me.next()
            Loop
        End If

        v = Double.Parse(n, New System.Globalization.CultureInfo("en-US"))


        Return v
    End Function

    Private Function word() As Object
        Select Case ch
            Case "t"c
                If Me.next() = "r"c AndAlso Me.next() = "u"c AndAlso Me.next() = "e"c Then
                    Me.next()
                    Return True
                End If
            Case "f"c
                If Me.next() = "a"c AndAlso Me.next() = "l"c AndAlso Me.next() = "s"c AndAlso Me.next() = "e"c Then
                    Me.next()
                    Return False
                End If
            Case "n"c
                If Me.next() = "u"c AndAlso Me.next() = "l"c AndAlso Me.next() = "l"c Then
                    Me.next()
                    Return Nothing
                End If
        End Select
        Throw New Exception("Syntax error")
    End Function

    Private Sub SkipObject()
        While (Me.next() <> "}" And ch <> "")

        End While
    End Sub

    Private Function value(Optional ByVal ClassType As Type = Nothing) As Object
        Me.white()
        Select Case ch
            Case "{"c
                If ClassType IsNot Nothing AndAlso ClassType.Name.ToLower = "object" Then
                    SkipObject()
                    Me.next()
                    Return Nothing
                Else
                    Return Me.obj(Activator.CreateInstance(ClassType))
                End If
            Case "["c
                If ClassType IsNot Nothing AndAlso ClassType.IsArray Then
                    Return Me.arr(ClassType.GetElementType)
                Else
                    Return Me.arr()
                End If

            Case """"c
                Return Me.str()
            Case "-"c
                Return Me.num()
            Case Else
                Return If(ch >= "0"c AndAlso ch <= "9"c, Me.num(), Me.word())
        End Select
    End Function

    Function parse(ByVal _text As String, ByVal _classType As Type) As Object
        text = _text
        at = 0
        ch = " "c
        
        Return value(_classType)
    End Function
End Class